function parseLOLScripts()
{
   var elem, len, i, ret = [];
 
   elem = document.getElementsByTagName('script');
   len  = elem.length;
 
   for(i=0;i<len;i++)
   {
      if(elem[i].type == 'text/lolcode')
      {
         parseLOLScript(elem[i]);
      }
   }
}
 
 
function parseLOLScript(lolScript)
{
   var lines, i, len, curLine, j, output = [], nScript, preLen, preDefReplace, code;
 
   lines = lolScript.innerHTML.split("\n");
   len   = lines.length;
 
   preDefReplace = [
                      ['HAI', '/* start LOLcode */'],
                      ['KTHXBYE', '/* end LOLcode */'],
                      [/BTW ([a-zA-Z0-9\'=\" .,+!?\$#@%\()*^_-]+)+/g, '/* $1 */'],
                      [/([a-zA-Z0-9_-]+) UP ([a-zA-Z0-9_-]+)/g, '$1 + $2'],
                      [/UPZ ([a-zA-Z0-9_-]+)!!([a-zA-Z0-9\'=\" .,+!?\$#@%\()*^_-]+)+/g, '$1 += $2'],
                      [/UPZ ([a-zA-Z0-9_-]+)!!/g, '$1++'],
                      [/([a-zA-Z0-9)_-]+) NERF ([a-zA-Z)0-9_-]+)/g, '$1 - $2'],
                      [/NERFZ ([a-zA-Z0-9_-]+)!!([0-9])+/g, '$1 -= $2'],
                      [/NERFZ ([a-zA-Z0-9_-]+)!!/g, '$1--'],
                      [/([a-zA-Z0-9_-]+) TIEM ([a-zA-Z0-9_-]+)/g, '$1 * $2'],
                      [/TIEMZ ([a-zA-Z0-9_-]+)!!([0-9])+/g, '$1 *= $2'],
                      [/([a-zA-Z0-9_-]+) OVAR ([a-zA-Z0-9_-]+)/g, '$1 / $2'],
                      [/OVARZ ([a-zA-Z0-9_-]+)!!([0-9])+/g, '$1 /= $2'],
                      [/BIGR THAN/g, '>'],
                      [/SMALR THAN/g, '<'],
                      [/LIEKS/g, '==='],
                      [/LIEK/g, '=='],
                      [/NOT /g,'!'],
                      [/ IZ /g, ' = '],
                      [/LEFTOVAR/g, '%'],
                      [/I HAS A ([a-zA-Z0-9_-]+) ITZ [']([a-zA-Z0-9\s]+)'/g,'var $1 = \'$2\''], 
                      [/I HAS A ([a-zA-Z0-9_-]+) ITZ ["]([a-zA-Z0-9\s]+)"/g,'var $1 = "$2"'],   
                      [/I HAS A ([a-zA-Z0-9_-]+) ITZ ([a-zA-Z0-9]+)/g, 'var $1 = $2'],  
                      [/I HAS A ([a-zA-Z0-9_-]+)/g,'var $1'],
                      [/([a-zA-Z0-9_-]+) IZ [']([a-zA-Z0-9\s]+)'/g, '$1 = \'$2\''],
                      [/([a-zA-Z0-9_-]+) IZ ["]([a-zA-Z0-9\s]+)"/g, '$1 = \"$2\"'],
                      [/([a-zA-Z0-9_-]+) IZ ([a-zA-Z0-9\s]+)/g, '$1 = $2'],
                  [/IZ /g, 'if('],
                  [/\?/g, '){'],
                  [/NOWAI/g, '}else{'],
                  [/GTFO/g, 'break'],
                  [/IM IN UR TREADMIL/g, 'while(true){'],
                      [/BUKKIT [']([a-zA-Z0-9_-]+)'/g, "document.getElementById('$1')"],
                      [/BUKKIT ["]([a-zA-Z0-9_-]+)"/g, 'document.getElementById("$1")'],
                      [/ GUTS/g, '.innerHTML'],
 
 
                      ['KTHX', '}']
                   ];
 
   preLen = preDefReplace.length;
 
   for(i=0;i<len;i++)
   {
      if(lines[i].replace(/^\s+|\s+$/g,'') != '')
      {
         curLine = lines[i].replace(/^\s+/,"");
 
         for(j=0;j<preLen;j++)
         {
            curLine = curLine.replace(preDefReplace[j][0], preDefReplace[j][1]);
         }
         output[i] = curLine;
      }else{
         output[i] = '';
      }
   }
 
 
   nScript = document.createElement('script');
   nScript.setAttribute('type','text/javascript');
 
   for(i=0;i<len;i++)
   {
      code = document.createTextNode(output[i] + '\n');
      nScript.appendChild(code);
   }
 
   lolScript.parentNode.replaceChild(nScript,lolScript);
}
 
 
 
parseLOLScripts();